module NoDuplicates

open RelCalc

sig Nat {
    succ: Nat,
}

-- succ is an injection (required):
fact{
	RelCalc/Simple[succ, Nat]
	RelCalc/Entire[succ, Nat]
	RelCalc/Injective[succ, Nat]
}

-- getting closer to Nat
fact {
	all n : Nat | n !in n.succ  -- suc is not id, just for showing purposes
}

one sig One in Nat {}

sig Data {}

sig List {
	map : Nat -> Data
}
fact{
	all l: List | RelCalc/Simple[l.map, Data]
}

pred noDuplicates[l: List]{
	RelCalc/Injective[l.map, Nat]
}

pred cons[l': List, c: Data, l: List] {
	l'.map = ~(Nat->One).(Nat->c) + ~succ.(l.map)		
--	l'.map[One]=c && all i: Nat, x : Data | x = l.map[i] => x = l'.map[i.succ]
}

pred pre[l: List, c: Data] {
	l.map . ~(Nat->c) in succ.~(Nat->One)
}

assert invPObad {
	all c: Data, l',l:List {
		cons[l',c,l] && noDuplicates[l] => noDuplicates[l']
	}
}

assert invPO {
	all c: Data, l',l:List {
		(cons[l',c,l] && noDuplicates[l] && pre[l,c]) => noDuplicates[l']
	}
}
assert invPOwp {
	all c: Data, l',l:List {
		cons[l',c,l] => ((noDuplicates[l] && pre[l,c]) <=> noDuplicates[l'])
	}
}


check invPObad for 6 but 2 List
check invPOwp  for 6 but 2 List
check invPO      for 6 but 2 List

pred show () {} 
run show for 3 but 1 List 


